Freeciv-3.1: /fast/freeciv/nightly/S3_1/server/settings.h File Reference

Freeciv-3.1

Loading...
Searching...
No Matches
Data Structures | Macros | Functions
settings.h File Reference
`#include "shared.h"`
`#include "game.h"`
`#include "server_settings.h"`
`#include "specenum_gen.h"`
`#include "speclist.h"`

Go to the source code of this file.

## Data Structures

struct | sset_val_name

## Macros

#define | SPECENUM_NAME sset_category
#define | SPECENUM_VALUE0 SSET_GEOLOGY
#define | SPECENUM_VALUE0NAME N_("Geological")
#define | SPECENUM_VALUE1 SSET_SOCIOLOGY
#define | SPECENUM_VALUE1NAME N_("Sociological")
#define | SPECENUM_VALUE2 SSET_ECONOMICS
#define | SPECENUM_VALUE2NAME N_("Economic")
#define | SPECENUM_VALUE3 SSET_MILITARY
#define | SPECENUM_VALUE3NAME N_("Military")
#define | SPECENUM_VALUE4 SSET_SCIENCE
#define | SPECENUM_VALUE4NAME N_("Scientific")
#define | SPECENUM_VALUE5 SSET_INTERNAL
#define | SPECENUM_VALUE5NAME N_("Internal")
#define | SPECENUM_VALUE6 SSET_NETWORK
#define | SPECENUM_VALUE6NAME N_("Networking")
#define | SPECENUM_COUNT SSET_NUM_CATEGORIES
#define | SPECENUM_NAME sset_level
#define | SPECENUM_VALUE0 SSET_NONE
#define | SPECENUM_VALUE0NAME N_("?ssetlevel:None")
#define | SPECENUM_VALUE1 SSET_ALL
#define | SPECENUM_VALUE1NAME N_("All")
#define | SPECENUM_VALUE2 SSET_VITAL
#define | SPECENUM_VALUE2NAME N_("Vital")
#define | SPECENUM_VALUE3 SSET_SITUATIONAL
#define | SPECENUM_VALUE3NAME N_("Situational")
#define | SPECENUM_VALUE4 SSET_RARE
#define | SPECENUM_VALUE4NAME N_("Rare")
#define | SPECENUM_VALUE5 SSET_CHANGED
#define | SPECENUM_VALUE5NAME N_("Changed")
#define | SPECENUM_VALUE6 SSET_LOCKED
#define | SPECENUM_VALUE6NAME N_("Locked")
#define | SPECENUM_COUNT OLEVELS_NUM
#define | SPECLIST_TAG setting
#define | SPECLIST_TYPE struct setting
#define | setting_list_iterate(_setting_list, _setting) TYPED_LIST_ITERATE(struct setting, _setting_list, _setting)
#define | setting_list_iterate_end LIST_ITERATE_END
#define | settings_iterate(_level, _pset)
#define | settings_iterate_end

## Functions

struct setting * | setting_by_number (int id)
struct setting * | setting_by_name (const char *name)
int | setting_number (const struct setting *pset)
const char * | setting_name (const struct setting *pset)
const char * | setting_short_help (const struct setting *pset)
const char * | setting_extra_help (const struct setting *pset, bool constant)
enum sset_type | setting_type (const struct setting *pset)
enum sset_level | setting_level (const struct setting *pset)
enum sset_category | setting_category (const struct setting *pset)
bool | setting_is_changeable (const struct setting *pset, struct connection *caller, char *reject_msg, size_t reject_msg_len)
bool | setting_is_visible_at_level (const struct setting *pset, enum cmdlevel plevel)
bool | setting_is_visible (const struct setting *pset, struct connection *caller)
const char * | setting_value_name (const struct setting *pset, bool pretty, char *buf, size_t buf_len)
const char * | setting_default_name (const struct setting *pset, bool pretty, char *buf, size_t buf_len)
void | setting_set_to_default (struct setting *pset)
int | read_enum_value (const struct setting *pset)
const char * | setting_enum_secfile_str (secfile_data_t data, int val)
const char * | setting_bitwise_secfile_str (secfile_data_t data, int bit)
bool | setting_bool_set (struct setting *pset, const char *val, struct connection *caller, char *reject_msg, size_t reject_msg_len)
bool | setting_bool_validate (const struct setting *pset, const char *val, struct connection *caller, char *reject_msg, size_t reject_msg_len)
bool | setting_bool_get (struct setting *pset)
int | setting_int_min (const struct setting *pset)
int | setting_int_max (const struct setting *pset)
bool | setting_int_set (struct setting *pset, int val, struct connection *caller, char *reject_msg, size_t reject_msg_len)
bool | setting_int_validate (const struct setting *pset, int val, struct connection *caller, char *reject_msg, size_t reject_msg_len)
int | setting_int_get (struct setting *pset)
bool | setting_str_set (struct setting *pset, const char *val, struct connection *caller, char *reject_msg, size_t reject_msg_len)
bool | setting_str_validate (const struct setting *pset, const char *val, struct connection *caller, char *reject_msg, size_t reject_msg_len)
char * | setting_str_get (struct setting *pset)
const char * | setting_enum_val (const struct setting *pset, int val, bool pretty)
bool | setting_enum_set (struct setting *pset, const char *val, struct connection *caller, char *reject_msg, size_t reject_msg_len)
bool | setting_enum_validate (const struct setting *pset, const char *val, struct connection *caller, char *reject_msg, size_t reject_msg_len)
const char * | setting_bitwise_bit (const struct setting *pset, int bit, bool pretty)
bool | setting_bitwise_set (struct setting *pset, const char *val, struct connection *caller, char *reject_msg, size_t reject_msg_len)
bool | setting_bitwise_validate (const struct setting *pset, const char *val, struct connection *caller, char *reject_msg, size_t reject_msg_len)
int | setting_bitwise_get (struct setting *pset)
void | setting_action (const struct setting *pset)
bool | setting_non_default (const struct setting *pset)
bool | setting_locked (const struct setting *pset)
void | setting_lock_set (struct setting *pset, bool lock)
void | settings_game_start (void)
void | settings_game_save (struct section_file *file, const char *section)
void | settings_game_load (struct section_file *file, const char *section)
bool | settings_game_reset (void)
void | settings_init (bool act)
void | settings_reset (void)
void | settings_turn (void)
void | settings_free (void)
int | settings_number (void)
void | settings_list_update (void)
struct setting_list * | settings_list_get (enum sset_level level)
bool | settings_ruleset (struct section_file *file, const char *section, bool act)
void | send_server_setting (struct conn_list *dest, const struct setting *pset)
void | send_server_settings (struct conn_list *dest)
void | send_server_access_level_settings (struct conn_list *dest, enum cmdlevel old_level, enum cmdlevel new_level)
void | send_server_setting_control (struct connection *pconn)
void | setting_changed (struct setting *pset)
enum setting_default_level | setting_get_setdef (const struct setting *pset)

## Macro Definition Documentation

## ◆ setting_list_iterate

#define setting_list_iterate | ( |  | _setting_list,
|  |  | _setting
| ) |  | TYPED_LIST_ITERATE(struct setting, _setting_list, _setting)

Definition at line 170 of file settings.h.

## ◆ setting_list_iterate_end

#define setting_list_iterate_end LIST_ITERATE_END

Definition at line 172 of file settings.h.

## ◆ settings_iterate

#define settings_iterate | ( |  | _level,
|  |  | _pset
| ) |  |

Value:
{ \
struct setting_list *_setting_list = settings_list_get(_level); \
if (_setting_list != NULL) { \
setting_list_iterate(_setting_list, _pset) {
settings_list_get
struct setting_list * settings_list_get(enum sset_level level)
Definition settings.c:5312

Definition at line 177 of file settings.h.

## ◆ settings_iterate_end

#define settings_iterate_end

Value:
} setting_list_iterate_end; \
} \
}
setting_list_iterate_end
#define setting_list_iterate_end
Definition settings.h:172

Definition at line 183 of file settings.h.

## ◆ SPECENUM_COUNT [1/2]

#define SPECENUM_COUNT SSET_NUM_CATEGORIES

Definition at line 53 of file settings.h.

## ◆ SPECENUM_COUNT [2/2]

#define SPECENUM_COUNT OLEVELS_NUM

Definition at line 53 of file settings.h.

## ◆ SPECENUM_NAME [1/2]

#define SPECENUM_NAME sset_category

Definition at line 37 of file settings.h.

## ◆ SPECENUM_NAME [2/2]

#define SPECENUM_NAME sset_level

Definition at line 37 of file settings.h.

## ◆ SPECENUM_VALUE0 [1/2]

#define SPECENUM_VALUE0 SSET_GEOLOGY

Definition at line 38 of file settings.h.

## ◆ SPECENUM_VALUE0 [2/2]

#define SPECENUM_VALUE0 SSET_NONE

Definition at line 38 of file settings.h.

## ◆ SPECENUM_VALUE0NAME [1/2]

#define SPECENUM_VALUE0NAME N_("Geological")

Definition at line 39 of file settings.h.

## ◆ SPECENUM_VALUE0NAME [2/2]

#define SPECENUM_VALUE0NAME N_("?ssetlevel:None")

Definition at line 39 of file settings.h.

## ◆ SPECENUM_VALUE1 [1/2]

#define SPECENUM_VALUE1 SSET_SOCIOLOGY

Definition at line 40 of file settings.h.

## ◆ SPECENUM_VALUE1 [2/2]

#define SPECENUM_VALUE1 SSET_ALL

Definition at line 40 of file settings.h.

## ◆ SPECENUM_VALUE1NAME [1/2]

#define SPECENUM_VALUE1NAME N_("Sociological")

Definition at line 41 of file settings.h.

## ◆ SPECENUM_VALUE1NAME [2/2]

#define SPECENUM_VALUE1NAME N_("All")

Definition at line 41 of file settings.h.

## ◆ SPECENUM_VALUE2 [1/2]

#define SPECENUM_VALUE2 SSET_ECONOMICS

Definition at line 42 of file settings.h.

## ◆ SPECENUM_VALUE2 [2/2]

#define SPECENUM_VALUE2 SSET_VITAL

Definition at line 42 of file settings.h.

## ◆ SPECENUM_VALUE2NAME [1/2]

#define SPECENUM_VALUE2NAME N_("Economic")

Definition at line 43 of file settings.h.

## ◆ SPECENUM_VALUE2NAME [2/2]

#define SPECENUM_VALUE2NAME N_("Vital")

Definition at line 43 of file settings.h.

## ◆ SPECENUM_VALUE3 [1/2]

#define SPECENUM_VALUE3 SSET_MILITARY

Definition at line 44 of file settings.h.

## ◆ SPECENUM_VALUE3 [2/2]

#define SPECENUM_VALUE3 SSET_SITUATIONAL

Definition at line 44 of file settings.h.

## ◆ SPECENUM_VALUE3NAME [1/2]

#define SPECENUM_VALUE3NAME N_("Military")

Definition at line 45 of file settings.h.

## ◆ SPECENUM_VALUE3NAME [2/2]

#define SPECENUM_VALUE3NAME N_("Situational")

Definition at line 45 of file settings.h.

## ◆ SPECENUM_VALUE4 [1/2]

#define SPECENUM_VALUE4 SSET_SCIENCE

Definition at line 46 of file settings.h.

## ◆ SPECENUM_VALUE4 [2/2]

#define SPECENUM_VALUE4 SSET_RARE

Definition at line 46 of file settings.h.

## ◆ SPECENUM_VALUE4NAME [1/2]

#define SPECENUM_VALUE4NAME N_("Scientific")

Definition at line 47 of file settings.h.

## ◆ SPECENUM_VALUE4NAME [2/2]

#define SPECENUM_VALUE4NAME N_("Rare")

Definition at line 47 of file settings.h.

## ◆ SPECENUM_VALUE5 [1/2]

#define SPECENUM_VALUE5 SSET_INTERNAL

Definition at line 48 of file settings.h.

## ◆ SPECENUM_VALUE5 [2/2]

#define SPECENUM_VALUE5 SSET_CHANGED

Definition at line 48 of file settings.h.

## ◆ SPECENUM_VALUE5NAME [1/2]

#define SPECENUM_VALUE5NAME N_("Internal")

Definition at line 49 of file settings.h.

## ◆ SPECENUM_VALUE5NAME [2/2]

#define SPECENUM_VALUE5NAME N_("Changed")

Definition at line 49 of file settings.h.

## ◆ SPECENUM_VALUE6 [1/2]

#define SPECENUM_VALUE6 SSET_NETWORK

Definition at line 50 of file settings.h.

## ◆ SPECENUM_VALUE6 [2/2]

#define SPECENUM_VALUE6 SSET_LOCKED

Definition at line 50 of file settings.h.

## ◆ SPECENUM_VALUE6NAME [1/2]

#define SPECENUM_VALUE6NAME N_("Networking")

Definition at line 51 of file settings.h.

## ◆ SPECENUM_VALUE6NAME [2/2]

#define SPECENUM_VALUE6NAME N_("Locked")

Definition at line 51 of file settings.h.

## ◆ SPECLIST_TAG

#define SPECLIST_TAG setting

Definition at line 166 of file settings.h.

## ◆ SPECLIST_TYPE

#define SPECLIST_TYPE struct setting

Definition at line 167 of file settings.h.

## Function Documentation

## ◆ read_enum_value()

int read_enum_value | ( | const struct setting * | pset | ) |

Helper function to read value from enumerator setting

Definition at line 3805 of file settings.c.

Referenced by plrcol_action(), save_game_ruleset(), send_server_setting(), setting_game_set(), setting_non_default(), setting_ruleset_one(), setting_value_name(), settings_game_load(), and settings_game_save().

## ◆ send_server_access_level_settings()

void send_server_access_level_settings | ( | struct conn_list * | dest,
|  | enum cmdlevel | old_level,
|  | enum cmdlevel | new_level
| ) |  |

Send the server settings that got a different visibility or changability after a connection access level change. Usually called when the access level of the user changes.

Definition at line 5145 of file settings.c.

Referenced by conn_set_access().

## ◆ send_server_setting()

void send_server_setting | ( | struct conn_list * | dest,
|  | const struct setting * | pset
| ) |  |

Tell the client about just one server setting. Call this after a setting is saved.

Definition at line 5014 of file settings.c.

Referenced by metamessage_command(), send_server_access_level_settings(), send_server_settings(), and set_command().

## ◆ send_server_setting_control()

void send_server_setting_control | ( | struct connection * | pconn | ) |

Tell the client about all server settings.

Definition at line 5177 of file settings.c.

Referenced by establish_new_connection().

## ◆ send_server_settings()

void send_server_settings | ( | struct conn_list * | dest | ) |

Tell the client about all server settings.

Definition at line 5133 of file settings.c.

Referenced by establish_new_connection(), load_command(), reset_command(), settings_ruleset(), and srv_running().

## ◆ setting_action()

void setting_action | ( | const struct setting * | pset | ) |

Execute the action callback if needed.

Definition at line 4168 of file settings.c.

Referenced by set_command(), settings_game_load(), settings_init(), settings_reset(), and settings_ruleset().

## ◆ setting_bitwise_bit()

const char * setting_bitwise_bit | ( | const struct setting * | pset,
|  | int | bit,
|  | bool | pretty
| ) |  |

Convert the bit number to its string representation. Return NULL if 'bit' is not a valid bit.

Definition at line 3887 of file settings.c.

Referenced by manual_command(), and show_help_option().

## ◆ setting_bitwise_get()

int setting_bitwise_get | ( | struct setting * | pset | ) |

Get value of bitwise setting

Definition at line 4056 of file settings.c.

Referenced by save_game_ruleset(), and server_ss_val_bitwise_get().

## ◆ setting_bitwise_secfile_str()

const char * setting_bitwise_secfile_str | ( | secfile_data_t | data,
|  | int | bit
| ) |  |

Convert the integer to the long support string representation of an enumerator. This function must match the secfile_enum_name_data_fn_t type.

Definition at line 3875 of file settings.c.

Referenced by save_game_ruleset(), setting_ruleset_one(), settings_game_load(), and settings_game_save().

## ◆ setting_bitwise_set()

bool setting_bitwise_set | ( | struct setting * | pset,
|  | const char * | val,
|  | struct connection * | caller,
|  | char * | reject_msg,
|  | size_t | reject_msg_len
| ) |  |

Set the setting to 'val'. Returns TRUE on success. If it fails, the reason of the failure is available in the optional parameter 'reject_msg'.

Definition at line 4022 of file settings.c.

Referenced by set_command(), and setting_game_restore().

## ◆ setting_bitwise_validate()

bool setting_bitwise_validate | ( | const struct setting * | pset,
|  | const char * | val,
|  | struct connection * | caller,
|  | char * | reject_msg,
|  | size_t | reject_msg_len
| ) |  |

Returns TRUE if 'val' is a valid value for this setting. If it's not, the reason of the failure is available in the optional parameter 'reject_msg'.

Definition at line 4043 of file settings.c.

Referenced by set_command().

## ◆ setting_bool_get()

bool setting_bool_get | ( | struct setting * | pset | ) |

Get value of boolean setting

Definition at line 3496 of file settings.c.

Referenced by save_game_ruleset(), and server_ss_val_bool_get().

## ◆ setting_bool_set()

bool setting_bool_set | ( | struct setting * | pset,
|  | const char * | val,
|  | struct connection * | caller,
|  | char * | reject_msg,
|  | size_t | reject_msg_len
| ) |  |

Set the setting to 'val'. Returns TRUE on success. If it's not, the reason of the failure is available in the optional parameter 'reject_msg'.

Definition at line 3477 of file settings.c.

Referenced by set_command(), and setting_game_restore().

## ◆ setting_bool_validate()

bool setting_bool_validate | ( | const struct setting * | pset,
|  | const char * | val,
|  | struct connection * | caller,
|  | char * | reject_msg,
|  | size_t | reject_msg_len
| ) |  |

Returns TRUE if 'val' is a valid value for this setting. If it's not, the reason of the failure is available in the optional parameter 'reject_msg'.

Definition at line 3508 of file settings.c.

Referenced by set_command().

## ◆ setting_by_name()

struct setting * setting_by_name | ( | const char * | name | ) |

Returns the setting to the given name.

Definition at line 3138 of file settings.c.

Referenced by api_server_setting_get(), autolock_settings(), metamessage_command(), rscompat_req_vec_adjust_3_1(), sanity_check_req_vec_singlepole(), sanity_check_setting_is_game_rule(), server_ss_by_name(), and srv_ready().

## ◆ setting_by_number()

struct setting * setting_by_number | ( | int | id | ) |

Returns the setting to the given id.

Definition at line 3130 of file settings.c.

Referenced by optname_accessor(), rscompat_req_vec_adjust_3_1(), sanity_check_req_individual(), sanity_check_req_vec_singlepole(), sanity_check_server_setting_value_in_req(), server_ss_name_get(), server_ss_type_get(), server_ss_val_bitwise_get(), server_ss_val_bool_get(), server_ss_val_int_get(), settings_list_init(), settings_list_update(), show_help_option(), show_settings(), and validate_setting_arg().

## ◆ setting_category()

enum sset_category setting_category | ( | const struct setting * | pset | ) |

Access function for the setting category.

Definition at line 3207 of file settings.c.

Referenced by manual_command(), and sanity_check_setting_is_game_rule().

## ◆ setting_changed()

void setting_changed | ( | struct setting * | pset | ) |

Mark setting changed

Definition at line 5341 of file settings.c.

Referenced by metamessage_command(), and set_command().

## ◆ setting_default_name()

const char * setting_default_name | ( | const struct setting * | pset,
|  | bool | pretty,
|  | char * | buf,
|  | size_t | buf_len
| ) |  |

Compute the name of the default value of the setting.

Definition at line 4102 of file settings.c.

Referenced by manual_command(), and show_help_option().

## ◆ setting_enum_secfile_str()

const char * setting_enum_secfile_str | ( | secfile_data_t | data,
|  | int | val
| ) |  |

Convert the integer to the long support string representation of an enumerator. This function must match the secfile_enum_name_data_fn_t type.

Definition at line 3690 of file settings.c.

Referenced by save_game_ruleset(), setting_ruleset_one(), settings_game_load(), and settings_game_save().

## ◆ setting_enum_set()

bool setting_enum_set | ( | struct setting * | pset,
|  | const char * | val,
|  | struct connection * | caller,
|  | char * | reject_msg,
|  | size_t | reject_msg_len
| ) |  |

Set the setting to 'val'. Returns TRUE on success. If it fails, the reason of the failure is available in the optional parameter 'reject_msg'.

Definition at line 3832 of file settings.c.

Referenced by autolock_settings(), set_command(), setting_game_restore(), and srv_ready().

## ◆ setting_enum_val()

const char * setting_enum_val | ( | const struct setting * | pset,
|  | int | val,
|  | bool | pretty
| ) |  |

Convert the integer to the string representation of an enumerator. Return NULL if 'val' is not a valid enumerator.

Definition at line 3702 of file settings.c.

Referenced by manual_command(), and show_help_option().

## ◆ setting_enum_validate()

bool setting_enum_validate | ( | const struct setting * | pset,
|  | const char * | val,
|  | struct connection * | caller,
|  | char * | reject_msg,
|  | size_t | reject_msg_len
| ) |  |

Returns TRUE if 'val' is a valid value for this setting. If it's not, the reason of the failure is available in the optional parameter 'reject_msg'.

Definition at line 3861 of file settings.c.

Referenced by set_command().

## ◆ setting_extra_help()

const char * setting_extra_help | ( | const struct setting * | pset,
|  | bool | constant
| ) |  |

Access function for the long (extra) help of the setting. If 'constant' is TRUE, static, not-yet-translated string is always returned.

Definition at line 3179 of file settings.c.

Referenced by manual_command(), send_server_setting_control(), and show_help_option().

## ◆ setting_get_setdef()

enum setting_default_level setting_get_setdef | ( | const struct setting * | pset | ) |

Is the setting in changed state, or the default

Definition at line 5349 of file settings.c.

Referenced by save_game_ruleset(), settings_game_save(), and show_settings_one().

## ◆ setting_int_get()

int setting_int_get | ( | struct setting * | pset | ) |

Get value of integer setting

Definition at line 3608 of file settings.c.

Referenced by save_game_ruleset(), and server_ss_val_int_get().

## ◆ setting_int_max()

int setting_int_max | ( | const struct setting * | pset | ) |

Returns the maximal integer value for this setting.

Definition at line 3553 of file settings.c.

Referenced by manual_command(), show_help_option(), and show_settings_one().

## ◆ setting_int_min()

int setting_int_min | ( | const struct setting * | pset | ) |

Returns the minimal integer value for this setting.

Definition at line 3544 of file settings.c.

Referenced by manual_command(), show_help_option(), and show_settings_one().

## ◆ setting_int_set()

bool setting_int_set | ( | struct setting * | pset,
|  | int | val,
|  | struct connection * | caller,
|  | char * | reject_msg,
|  | size_t | reject_msg_len
| ) |  |

Set the setting to 'val'. Returns TRUE on success. If it fails, the reason of the failure is available by the function setting_error().

Definition at line 3563 of file settings.c.

Referenced by set_command(), setting_game_restore(), and setting_ruleset_one().

## ◆ setting_int_validate()

bool setting_int_validate | ( | const struct setting * | pset,
|  | int | val,
|  | struct connection * | caller,
|  | char * | reject_msg,
|  | size_t | reject_msg_len
| ) |  |

Returns TRUE if 'val' is a valid value for this setting. If it's not, the reason of the failure is available by the function setting_error().

FIXME: also check the access level of pconn.

Definition at line 3583 of file settings.c.

Referenced by set_command(), and setting_int_set().

## ◆ setting_is_changeable()

bool setting_is_changeable | ( | const struct setting * | pset,
|  | struct connection * | caller,
|  | char * | reject_msg,
|  | size_t | reject_msg_len
| ) |  |

Returns whether the specified server setting (option) can currently be changed by the caller. If it returns FALSE, the reason of the failure is available by the function setting_error().

Definition at line 3289 of file settings.c.

Referenced by default_command(), manual_command(), set_command(), setting_bitwise_set(), setting_bool_set(), setting_enum_set(), setting_game_restore(), setting_int_set(), setting_status(), setting_str_set(), settings_game_load(), settings_reset(), and show_help_option().

## ◆ setting_is_visible()

bool setting_is_visible | ( | const struct setting * | pset,
|  | struct connection * | caller
| ) |  |

Returns whether the specified server setting (option) can be seen by the caller.

Definition at line 3326 of file settings.c.

Referenced by set_command(), show_help_option(), show_help_option_list(), and show_settings().

## ◆ setting_is_visible_at_level()

bool setting_is_visible_at_level | ( | const struct setting * | pset,
|  | enum cmdlevel | plevel
| ) |  |

Returns whether the specified server setting (option) can be seen by a caller with the specified access level.

Definition at line 3316 of file settings.c.

Referenced by sanity_check_setting_is_seen(), and setting_is_visible().

## ◆ setting_level()

enum sset_level setting_level | ( | const struct setting * | pset | ) |

Access function for the setting level (used by the /show command).

Definition at line 3199 of file settings.c.

Referenced by manual_command(), and settings_list_init().

## ◆ setting_lock_set()

void setting_lock_set | ( | struct setting * | pset,
|  | bool | lock
| ) |  |

Set the value for the lock of a setting.

Definition at line 4428 of file settings.c.

Referenced by autolock_settings(), setting_ruleset_one(), settings_init(), and settings_ruleset().

## ◆ setting_locked()

bool setting_locked | ( | const struct setting * | pset | ) |

Returns if the setting is locked by the ruleset.

Definition at line 4420 of file settings.c.

Referenced by manual_command(), save_game_ruleset(), setting_is_changeable(), setting_status(), and settings_list_update().

## ◆ setting_name()

const char * setting_name | ( | const struct setting * | pset | ) |

Access function for the setting name.

Definition at line 3162 of file settings.c.

Referenced by manual_command(), optname_accessor(), save_game_ruleset(), send_server_setting_control(), server_ss_name_get(), set_command(), setting_default_name(), setting_game_restore(), setting_is_changeable(), setting_is_free_to_change(), setting_non_default(), setting_ruleset_one(), setting_value_name(), settings_game_load(), settings_game_save(), settings_list_cmp(), settings_list_init(), show_help_option(), show_help_option_list(), show_settings(), show_settings_one(), srv_ready(), tolua_server_server_setting_get00(), and write_init_script().

## ◆ setting_non_default()

bool setting_non_default | ( | const struct setting * | pset | ) |

Returns whether the setting has non-default value.

Definition at line 4394 of file settings.c.

Referenced by manual_command(), settings_list_update(), and show_settings_one().

## ◆ setting_number()

int setting_number | ( | const struct setting * | pset | ) |

Returns the id to the given setting.

Definition at line 3153 of file settings.c.

Referenced by manual_command(), send_server_setting_control(), server_ss_by_name(), setting_default_name(), setting_is_free_to_change(), setting_non_default(), and setting_value_name().

## ◆ setting_set_to_default()

void setting_set_to_default | ( | struct setting * | pset | ) |

Update the setting to the default value

Definition at line 4138 of file settings.c.

Referenced by default_command(), setting_game_restore(), settings_init(), settings_reset(), and settings_ruleset().

## ◆ setting_short_help()

const char * setting_short_help | ( | const struct setting * | pset | ) |

Access function for the short help (not translated yet) of the setting.

Definition at line 3170 of file settings.c.

Referenced by manual_command(), send_server_setting_control(), and show_help_option().

## ◆ setting_str_get()

char * setting_str_get | ( | struct setting * | pset | ) |

Get value of string setting

Definition at line 3679 of file settings.c.

Referenced by save_game_ruleset().

## ◆ setting_str_set()

bool setting_str_set | ( | struct setting * | pset,
|  | const char * | val,
|  | struct connection * | caller,
|  | char * | reject_msg,
|  | size_t | reject_msg_len
| ) |  |

Set the setting to 'val'. Returns TRUE on success. If it fails, the reason of the failure is available by the function setting_error().

Definition at line 3634 of file settings.c.

Referenced by set_command(), setting_game_restore(), setting_ruleset_one(), and settings_game_load().

## ◆ setting_str_validate()

bool setting_str_validate | ( | const struct setting * | pset,
|  | const char * | val,
|  | struct connection * | caller,
|  | char * | reject_msg,
|  | size_t | reject_msg_len
| ) |  |

Returns TRUE if 'val' is a valid value for this setting. If it's not, the reason of the failure is available by the function setting_error().

FIXME: also check the access level of pconn.

Definition at line 3654 of file settings.c.

Referenced by set_command(), and setting_str_set().

## ◆ setting_type()

enum sset_type setting_type | ( | const struct setting * | pset | ) |

Access function for the setting type.

Definition at line 3191 of file settings.c.

Referenced by manual_command(), save_game_ruleset(), send_server_setting(), server_ss_type_get(), set_command(), setting_bitwise_get(), setting_bool_get(), setting_game_free(), setting_game_restore(), setting_game_set(), setting_int_get(), setting_non_default(), setting_str_get(), settings_game_save(), show_help_option(), and show_settings_one().

## ◆ setting_value_name()

const char * setting_value_name | ( | const struct setting * | pset,
|  | bool | pretty,
|  | char * | buf,
|  | size_t | buf_len
| ) |  |

Compute the name of the current value of the setting.

Definition at line 4066 of file settings.c.

Referenced by api_server_setting_get(), manual_command(), set_command(), setting_ruleset_one(), settings_game_load(), show_help_option(), show_settings_one(), srv_ready(), and write_init_script().

## ◆ settings_free()

void settings_free | ( | void |  | ) |

Deinitialize stuff related to this code module.

Definition at line 4993 of file settings.c.

Referenced by server_quit().

## ◆ settings_game_load()

void settings_game_load | ( | struct section_file * | file,
|  | const char * | section
| ) |  |

Restore all settings from a savegame.

Definition at line 4648 of file settings.c.

Referenced by sg_load_settings(), and sg_load_settings().

## ◆ settings_game_reset()

bool settings_game_reset | ( | void |  | ) |

Reset all settings to the values at game start.

Definition at line 4935 of file settings.c.

Referenced by reset_command().

## ◆ settings_game_save()

void settings_game_save | ( | struct section_file * | file,
|  | const char * | section
| ) |  |

Save game settings.

Definition at line 4561 of file settings.c.

Referenced by sg_save_settings().

## ◆ settings_game_start()

void settings_game_start | ( | void |  | ) |

Save setting values at the start of the game.

Definition at line 4548 of file settings.c.

Referenced by srv_ready().

## ◆ settings_init()

void settings_init | ( | bool | act | ) |

Initialize stuff related to this code module.

Definition at line 4952 of file settings.c.

Referenced by main(), and srv_prepare().

## ◆ settings_list_get()

struct setting_list * settings_list_get | ( | enum sset_level | level | ) |

Get a settings list of a certain level. Call settings_list_update() before if something was changed.

Definition at line 5312 of file settings.c.

## ◆ settings_list_update()

void settings_list_update | ( | void |  | ) |

Update sorted settings (changed and locked values).

Definition at line 5270 of file settings.c.

Referenced by settings_init(), and show_settings().

## ◆ settings_number()

int settings_number | ( | void |  | ) |

Returns the total number of settings.

Definition at line 5005 of file settings.c.

Referenced by explain_option(), lookup_option(), show_help(), and universal_kind_values().

## ◆ settings_reset()

void settings_reset | ( | void |  | ) |

Reset all settings iff they are changeable.

Definition at line 4971 of file settings.c.

Referenced by reset_command().

## ◆ settings_ruleset()

bool settings_ruleset | ( | struct section_file * | file,
|  | const char * | section,
|  | bool | act
| ) |  |

Load game settings from ruleset file 'game.ruleset'.

Definition at line 4178 of file settings.c.

Referenced by load_rulesetdir(), and reload_rulesets_settings().

## ◆ settings_turn()

void settings_turn | ( | void |  | ) |

Update stuff every turn that is related to this code module. Run this on turn end.

Definition at line 4985 of file settings.c.

Referenced by end_turn().